package com.cooksys.bootcamp.ballardFinal;

import com.cooksys.prep.model.Category;

// This is a convenience class for passing movie criteria to the FilmDao
public class MovieFilter
{
	// Data members are public, so we don't need getters and setters.
	// Privacy shouldn't be an issue since this is a fairly throw-away class
	public Category category;
	public String title;
	public String actorFirst;
	public String actorLast;
	public int perPage;
	public int pageNumber;
	
	// A simple constructor that takes in all the fields at once
	public MovieFilter(Category category, String title, String actorFirst, String actorLast, int perPage, int pageNumber)
	{
		this.category = category;
		this.title = title;
		this.actorFirst = actorFirst;
		this.actorLast = actorLast;
		this.perPage = perPage;
		this.pageNumber = pageNumber;
	}
	
	// Combine all the fields into a SQL query WHERE-ORDER-LIMIT clause
	public String toString()
	{
		String result = "";
		
		if (category != null)
		{
			result = result.concat("EXISTS(SELECT category_id FROM film_category WHERE film_category.film_id=film.film_id AND film_category.category_id=" + category.getCategoryId() + ") ");
		}
		if (!title.isEmpty())
		{
			if (!result.isEmpty()) result = result.concat("AND ");
			result = result.concat("INSTR(film.title, \"" + title.replaceAll("\"", "\\\"") + "\") > 0 ");
		}
		if (!actorFirst.isEmpty())
		{
			if (!result.isEmpty()) result = result.concat("AND ");
			result = result.concat("EXISTS(SELECT actor.first_name FROM film_actor LEFT JOIN actor ON actor.actor_id=film_actor.actor_id WHERE film_actor.film_id=film.film_id AND actor.first_name LIKE \"" + actorFirst.replaceAll("\"", "\\\"") + "%\") ");
		}
		if (!actorLast.isEmpty())
		{
			if (!result.isEmpty()) result = result.concat("AND ");
			result = result.concat("EXISTS(SELECT actor.last_name FROM film_actor LEFT JOIN actor ON actor.actor_id=film_actor.actor_id WHERE film_actor.film_id=film.film_id AND actor.last_name LIKE \"" + actorLast.replaceAll("\"", "\\\"") + "%\") ");
		}
		
		result = result.concat("ORDER BY film.title ASC LIMIT " + (perPage*pageNumber) + "," + perPage);
		
		return result;
	}
}
