package com.cooksys.prep.dao;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.cooksys.prep.model.Category;

public class CategoryDao extends HibernateDaoSupport
{
	public void save(Category category){
		getHibernateTemplate().save(category);
	}
 
	public void update(Category category){
		getHibernateTemplate().update(category);
	}
 
	public void delete(Category category){
		getHibernateTemplate().delete(category);
	}
	
	public Category findById(short categoryId){
		List list = getHibernateTemplate().find(
                      "from Category where category_id=?",categoryId
                );
		if (list.isEmpty()) return null;
		else return (Category)list.get(0);
	}
	
	public Category[] findAll(){
		List<Category> list = getHibernateTemplate().find("from Category category order by category.name ASC");
		
		return (Category[])list.toArray(new Category[0]);
	}
}
