package com.cooksys.prep.dao;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.cooksys.prep.model.City;
import com.cooksys.prep.model.Country;

public class CityDao extends HibernateDaoSupport
{
	public void save(City city){
		getHibernateTemplate().save(city);
	}
 
	public void update(City city){
		getHibernateTemplate().update(city);
	}
 
	public void delete(City city){
		getHibernateTemplate().delete(city);
	}
	
	public City findById(short cityId){
		List list = getHibernateTemplate().find(
                      "from City where city_id=?",cityId
                );
		if (list.isEmpty()) return null;
		else return (City)list.get(0);
	}
	
	public City[] findByCountry(Country country)
	{
		List<City> list = getHibernateTemplate().find("from City city where city.country=?", country);
		
		return (City[])list.toArray(new City[0]);
	}
	
}
