package com.cooksys.prep.dao;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.cooksys.prep.model.Film;
import com.cooksys.prep.model.FilmActor;

public class FilmActorDao extends HibernateDaoSupport
{
	public void save(FilmActor filmActor){
		getHibernateTemplate().save(filmActor);
	}
 
	public void update(FilmActor filmActor){
		getHibernateTemplate().update(filmActor);
	}
 
	public void delete(FilmActor filmActor){
		getHibernateTemplate().delete(filmActor);
	}
	
	public FilmActor[] findByFilm(Film film){
		List<FilmActor> list = getHibernateTemplate().find(
                      "from FilmActor filmActor left join fetch filmActor.actor actor where filmActor.film=? ORDER BY actor.lastName ASC",film
                );

		return (FilmActor[])list.toArray(new FilmActor[0]);
	}
	
	public FilmActor findByActorId(short filmActorId){
		List list = getHibernateTemplate().find(
                      "from FilmActor where actor_id=?",filmActorId
                );
		if (list.isEmpty()) return null;
		else return (FilmActor)list.get(0);
	}
}
