package com.cooksys.prep.dao;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.cooksys.prep.model.Film;
import com.cooksys.prep.model.FilmCategory;

public class FilmCategoryDao extends HibernateDaoSupport
{
	public void save(FilmCategory filmCategory){
		getHibernateTemplate().save(filmCategory);
	}
 
	public void update(FilmCategory filmCategory){
		getHibernateTemplate().update(filmCategory);
	}
 
	public void delete(FilmCategory filmCategory){
		getHibernateTemplate().delete(filmCategory);
	}
	
	public FilmCategory[] findByFilm(Film film){
		List<FilmCategory> list = getHibernateTemplate().find(
                      "from FilmCategory filmCategory left join fetch filmCategory.category where filmCategory.film=?",film
                );
		
		return (FilmCategory[])list.toArray(new FilmCategory[0]);
	}
	
	public FilmCategory findByCategoryId(short filmCategoryId){
		List list = getHibernateTemplate().find(
                      "from FilmCategory where category_id=?",filmCategoryId
                );
		if (list.isEmpty()) return null;
		else return (FilmCategory)list.get(0);
	}
}
