package com.cooksys.prep.dao;

import java.util.List;

import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.cooksys.bootcamp.ballardFinal.MovieFilter;
import com.cooksys.prep.model.Film;

public class FilmDao extends HibernateDaoSupport
{
	public void save(Film film){
		getHibernateTemplate().save(film);
	}
 
	public void update(Film film){
		getHibernateTemplate().update(film);
	}
 
	public void delete(Film film){
		getHibernateTemplate().delete(film);
	}
	
	public Film findById(short filmId){
		List list = getHibernateTemplate().find(
                      "from Film where film_id=?",filmId
                );
		if (list.isEmpty()) return null;
		else return (Film)list.get(0);
	}
	
	public Film[] findAll(){
		List<Film> list = getHibernateTemplate().find("from Film film ORDER BY film.title ASC");
		return (Film[])list.toArray(new Film[0]);
	}
	
	public Film[] findAll(MovieFilter movieFilter)
	{
		Session session = getHibernateTemplate().getSessionFactory().openSession();
		SQLQuery query = session.createSQLQuery("SELECT film.film_id FROM film " + (movieFilter.toString().startsWith("ORDER BY")?"":"WHERE ")  + movieFilter.toString());
		List results = query.list();
		
		Film[] filmList = new Film[results.size()];
		
		for (int i=0; i<results.size(); i++)
		{
			List<Film> list = getHibernateTemplate().find("from Film film WHERE film.filmId=?", ((Short)results.get(i)).shortValue());
			filmList[i] = list.get(0);
		}
		
		return filmList;
	}
}
