package com.cooksys.prep.dao;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.cooksys.prep.model.Film;
import com.cooksys.prep.model.Inventory;

public class InventoryDao extends HibernateDaoSupport
{
	public void save(Inventory inventory){
		getHibernateTemplate().save(inventory);
	}
 
	public void update(Inventory inventory){
		getHibernateTemplate().update(inventory);
	}
 
	public void delete(Inventory inventory){
		getHibernateTemplate().delete(inventory);
	}
	
	public Inventory findById(short inventoryId){
		List list = getHibernateTemplate().find(
                      "from Inventory where inventory_id=?",inventoryId
                );
		if (list.isEmpty()) return null;
		else return (Inventory)list.get(0);
	}
	
	public Inventory[] findAllRentable(Film film){
		List<Inventory> list = getHibernateTemplate().find("from Inventory inventory where inventory.film=? AND NOT EXISTS (FROM Rental rental WHERE inventory=rental.inventory AND rental.returnDate IS NULL)", film);
		return (Inventory[])list.toArray(new Inventory[0]);
	}
}
