package com.cooksys.prep.dao;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.cooksys.prep.model.Customer;
import com.cooksys.prep.model.Rental;

public class RentalDao extends HibernateDaoSupport
{
	public void save(Rental rental){
		getHibernateTemplate().save(rental);
	}
 
	public void update(Rental rental){
		getHibernateTemplate().update(rental);
	}
 
	public void delete(Rental rental){
		getHibernateTemplate().delete(rental);
	}
 
	public Rental findById(short rentalId){
		List list = getHibernateTemplate().find(
                      "from Rental where rental_id=?",rentalId
                );
		if (list.isEmpty()) return null;
		else return (Rental)list.get(0);
	}
	
	public Rental[] findByCustomer(Customer customer){
		List<Rental> list = getHibernateTemplate().find(
                      "from Rental where customer_id=?",customer
                );
		return (Rental[])list.toArray(new Rental[0]);
	}
	
	public Rental[] findDueByCustomer(Customer customer){
		List<Rental> list = getHibernateTemplate().find(
                      "from Rental rental join fetch rental.inventory inventory join fetch inventory.film where rental.customer=? and rental.returnDate IS NULL and EXISTS(FROM Payment payment WHERE payment.rental=rental)",customer
                );
		return (Rental[])list.toArray(new Rental[0]);
	}
	
	public Rental[] findReservedByCustomer(Customer customer){
		List<Rental> list = getHibernateTemplate().find(
                      "from Rental rental join fetch rental.inventory inventory join fetch inventory.film where rental.customer=? and rental.returnDate IS NULL and NOT EXISTS(FROM Payment payment WHERE payment.rental=rental)",customer
                );
		return (Rental[])list.toArray(new Rental[0]);
	}
	
}
